diff --git a/dlls/dinput/effect_linuxinput.c b/dlls/dinput/effect_linuxinput.c
index 640b527c4e2..dcd4f5be1e0 100644
--- a/dlls/dinput/effect_linuxinput.c
+++ b/dlls/dinput/effect_linuxinput.c
@@ -19,7 +19,12 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
+#if 0
+#pragma makedep unix
+#endif
+
 #include "config.h"
+#include "wine/port.h"
 
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
 
@@ -44,6 +49,7 @@
 
 #include "device_private.h"
 #include "joystick_private.h"
+#include "unixlib_private.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
@@ -685,7 +691,7 @@ static void CDECL unix_effect_destroy(struct unix_effect *ptr)
 {
     unix_effect_stop(ptr);
     unix_effect_unload(ptr);
-    HeapFree(GetProcessHeap(), 0, ptr);
+    free(ptr);
 }
 
 static const struct unix_effect_vtbl unix_effect_vtbl =
@@ -725,7 +731,7 @@ DECLSPEC_HIDDEN HRESULT linuxinput_create_effect(int *fd, REFGUID rguid, DWORD t
         return DIERR_INVALIDPARAM;
     }
 
-    if (!(newEffect = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newEffect))))
+    if (!(newEffect = calloc(1, sizeof(*newEffect))))
         return DIERR_OUTOFMEMORY;
 
     newEffect->fd = fd;
@@ -777,7 +783,7 @@ DECLSPEC_HIDDEN HRESULT linuxinput_create_effect(int *fd, REFGUID rguid, DWORD t
             DIEP_STARTDELAY | DIEP_TRIGGERBUTTON | DIEP_TRIGGERREPEATINTERVAL | DIEP_TYPESPECIFICPARAMS);
     if (hr != DI_OK && hr != DI_DOWNLOADSKIPPED)
     {
-        HeapFree(GetProcessHeap(), 0, newEffect);
+        free(newEffect);
         return hr;
     }
 
@@ -796,7 +802,7 @@ DECLSPEC_HIDDEN HRESULT linuxinput_get_info_A(
 {
     DWORD type = typeFromGUID(rguid);
 
-    TRACE("(%d, %s, %p) type=%d\n", fd, _dump_dinput_GUID(rguid), info, type);
+    TRACE("(%d, %s, %p) type=%d\n", fd, debugstr_guid(rguid), info, type);
 
     if (!info) return E_POINTER;
 
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 2e28c0cacee..66ce63eb8e9 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -273,16 +273,6 @@ DWORD typeFromGUID(REFGUID guid)
     }
 }
 
-DWORD get_device_type(DWORD version, BOOL is_joystick)
-{
-    if (is_joystick)
-        return version >= 0x0800 ? DI8DEVTYPE_JOYSTICK | (DI8DEVTYPEJOYSTICK_STANDARD << 8) :
-                    DIDEVTYPE_JOYSTICK | (DIDEVTYPEJOYSTICK_TRADITIONAL << 8);
-
-    return version >= 0x0800 ? DI8DEVTYPE_GAMEPAD | (DI8DEVTYPEJOYSTICK_STANDARD << 8) :
-                DIDEVTYPE_JOYSTICK | (DIDEVTYPEJOYSTICK_GAMEPAD << 8);
-}
-
 static void _dump_DIEFFECT_flags(DWORD dwFlags)
 {
     if (TRACE_ON(dinput)) {
@@ -1204,24 +1194,6 @@ static LONG joystick_map_axis(ObjProps *props, int val)
     return ret;
 }
 
-/*
- * Maps POV x & y event values to a DX "clock" position:
- *         0
- *   31500    4500
- * 27000  -1    9000
- *   22500   13500
- *       18000
- */
-DWORD joystick_map_pov(const POINTL *p)
-{
-    if (p->x > 0)
-        return p->y < 0 ?  4500 : !p->y ?  9000 : 13500;
-    else if (p->x < 0)
-        return p->y < 0 ? 31500 : !p->y ? 27000 : 22500;
-    else
-        return p->y < 0 ?     0 : !p->y ?    -1 : 18000;
-}
-
 /*
  * Setup the dinput options.
  */
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index c5194720e4c..0e7bcef352a 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -25,6 +25,10 @@
  *	force feedback
  */
 
+#if 0
+#pragma makedep unix
+#endif
+
 #include "config.h"
 #include "wine/port.h"
 
@@ -65,6 +69,7 @@
 #include "dinput_private.h"
 #include "device_private.h"
 #include "joystick_private.h"
+#include "unixlib_private.h"
 
 #ifdef HAVE_LINUX_22_JOYSTICK_API
 
@@ -348,9 +353,9 @@ static INT find_joystick_devices(void)
         close(fd);
 
         if (!joystick_devices_count)
-            new_joydevs = HeapAlloc(GetProcessHeap(), 0, sizeof(struct JoyDev));
+            new_joydevs = malloc(sizeof(struct JoyDev));
         else
-            new_joydevs = HeapReAlloc(GetProcessHeap(), 0, joystick_devices,
+            new_joydevs = realloc(joystick_devices,
                                       (joystick_devices_count + 1) * sizeof(struct JoyDev));
         if (!new_joydevs) continue;
 
@@ -458,7 +463,7 @@ static HRESULT CDECL joydev_create_unix_joystick(REFGUID guid, DWORD version, co
 
     fill_joystick_dideviceinstanceA(info, version, index);
 
-    if (!(newDevice = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
+    if (!(newDevice = calloc(1, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
     newDevice->joydev = joydev;
     newDevice->joyfd = -1;
 
@@ -506,7 +511,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGener
 static void CDECL unix_joystick_destroy(struct unix_joystick *ptr)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    HeapFree(GetProcessHeap(), 0, This);
+    free(This);
 }
 
 #undef MAX_JOYSTICKS
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 1e72dd59339..e964a4ca863 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -20,6 +20,10 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
+#if 0
+#pragma makedep unix
+#endif
+
 #include "config.h"
 #include "wine/port.h"
 
@@ -63,6 +67,7 @@
 #include "dinput_private.h"
 #include "device_private.h"
 #include "joystick_private.h"
+#include "unixlib_private.h"
 
 #ifdef HAS_PROPER_HEADER
 
@@ -290,7 +295,7 @@ static void find_joydevs(void)
             test_bit(joydev.keybits, BTN_GEAR_DOWN) ||
             test_bit(joydev.keybits, BTN_DEAD);
 
-        if (!(joydev.device = HeapAlloc(GetProcessHeap(), 0, strlen(buf) + 1)))
+        if (!(joydev.device = malloc(strlen(buf) + 1)))
         {
             close(fd);
             continue;
@@ -299,7 +304,7 @@ static void find_joydevs(void)
 
         buf[MAX_PATH - 1] = 0;
         if (ioctl(fd, EVIOCGNAME(MAX_PATH - 1), buf) != -1 &&
-            (joydev.name = HeapAlloc(GetProcessHeap(), 0, strlen(buf) + strlen(EVDEVDRIVER) + 1)))
+            (joydev.name = malloc(strlen(buf) + strlen(EVDEVDRIVER) + 1)))
         {
             strcpy(joydev.name, buf);
             /* Append driver name */
@@ -399,9 +404,9 @@ static void find_joydevs(void)
         }
 
         if (!have_joydevs)
-            new_joydevs = HeapAlloc(GetProcessHeap(), 0, sizeof(struct JoyDev));
+            new_joydevs = malloc(sizeof(struct JoyDev));
         else
-            new_joydevs = HeapReAlloc(GetProcessHeap(), 0, joydevs, (1 + have_joydevs) * sizeof(struct JoyDev));
+            new_joydevs = realloc(joydevs, (1 + have_joydevs) * sizeof(struct JoyDev));
 
         if (!new_joydevs)
         {
@@ -504,7 +509,7 @@ static HRESULT CDECL joydev_create_unix_joystick(REFGUID guid, DWORD version, co
 
     fill_joystick_dideviceinstanceA(info, version, index);
 
-    if (!(newDevice = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
+    if (!(newDevice = calloc(1, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
     newDevice->joyfd       = -1;
     newDevice->joydev = joydev;
 
@@ -593,7 +598,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGener
 static void CDECL unix_joystick_destroy(struct unix_joystick *ptr)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    HeapFree(GetProcessHeap(), 0, This);
+    free(This);
 }
 
 const struct dinput_device joystick_linuxinput_device = {
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index ff11e8514a0..406ea715c47 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -20,6 +20,10 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
+#if 0
+#pragma makedep unix
+#endif
+
 #include "config.h"
 #include "wine/port.h"
 
@@ -91,6 +95,7 @@
 #include "dinput_private.h"
 #include "device_private.h"
 #include "joystick_private.h"
+#include "unixlib_private.h"
 
 #ifdef HAVE_IOHIDMANAGERCREATE
 
@@ -1126,7 +1131,7 @@ static HRESULT CDECL joydev_create_unix_joystick(REFGUID guid, DWORD version, co
 
     fill_joystick_dideviceinstanceA(info, device, version, index, name);
 
-    if (!(newDevice = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
+    if (!(newDevice = calloc(1, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
     newDevice->id = index;
 
     *vid = get_device_property_long(device, CFSTR(kIOHIDVendorIDKey));
@@ -1199,7 +1204,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGener
 static void CDECL unix_joystick_destroy(struct unix_joystick *ptr)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    HeapFree(GetProcessHeap(), 0, This);
+    free(This);
 }
 
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value)
@@ -1264,7 +1269,7 @@ static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFG
         return DIERR_UNSUPPORTED;
     }
 
-    if (!(effect = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*effect)))) return DIERR_OUTOFMEMORY;
+    if (!(effect = calloc(1, sizeof(*effect)))) return DIERR_OUTOFMEMORY;
     effect->device = This;
 
     /* Mac's FFEFFECT and Win's DIEFFECT are binary identical. */
@@ -1272,7 +1277,7 @@ static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFG
                 effect_win_to_mac(guid), (FFEFFECT*)params, &effect->effect));
     if(FAILED(hr)){
         WARN("FFDeviceCreateEffect failed: %08x\n", hr);
-        HeapFree(GetProcessHeap(), 0, effect);
+        free(effect);
         return hr;
     }
 
@@ -1314,7 +1319,7 @@ static void CDECL unix_effect_destroy(struct unix_effect *ptr)
 {
     EffectImpl *This = impl_from_unix_effect(ptr);
     FFDeviceReleaseEffect(This->device->ff, This->effect);
-    HeapFree(GetProcessHeap(), 0, This);
+    free(This);
 }
 
 static HRESULT CDECL unix_effect_get_parameters(struct unix_effect *ptr, DIEFFECT *effect, DWORD flags)
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 34f2260173b..1d331d7fdef 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -75,13 +75,11 @@ struct unix_joystick_vtbl
 
 extern HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out) DECLSPEC_HIDDEN;
 
-DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
-
 extern BOOL device_disabled_registry(const WCHAR* name) DECLSPEC_HIDDEN;
 
 extern int CDECL dinput_unix_joystick_get_axis(JoystickGenericImpl *This, int index) DECLSPEC_HIDDEN;
 extern void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, WORD type, int index, DWORD data) DECLSPEC_HIDDEN;
 
-DWORD typeFromGUID(REFGUID guid) DECLSPEC_HIDDEN;
+extern DWORD typeFromGUID(REFGUID guid) DECLSPEC_HIDDEN;
 
 #endif /* __WINE_DLLS_DINPUT_JOYSTICK_PRIVATE_H */
diff --git a/dlls/dinput/unixlib.c b/dlls/dinput/unixlib.c
new file mode 100644
index 00000000000..cbf7c9a31d0
--- /dev/null
+++ b/dlls/dinput/unixlib.c
@@ -0,0 +1,202 @@
+/*
+ * Unix library entry points
+ *
+ * Copyright 2020 Rémi Bernon for CodeWeavers
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#if 0
+#pragma makedep unix
+#endif
+
+#include "config.h"
+#include "wine/port.h"
+
+#include <assert.h>
+#include <stdarg.h>
+#include <string.h>
+#include <stdlib.h>
+
+#include "ntstatus.h"
+#define WIN32_NO_STATUS
+#include "windef.h"
+#include "winternl.h"
+#include "initguid.h"
+
+#include "wine/debug.h"
+
+#include "unixlib_private.h"
+
+WINE_DEFAULT_DEBUG_CHANNEL(dinput);
+
+/* Windows uses this GUID for guidProduct on non-keyboard/mouse devices.
+ * Data1 contains the device VID (low word) and PID (high word).
+ * Data4 ends with the ASCII bytes "PIDVID".
+ */
+DEFINE_GUID(DInput_PIDVID_Product_GUID,0x00000000,0x0000,0x0000,0x00,0x00,0x50,0x49,0x44,0x56,0x49,0x44);
+DEFINE_GUID(GUID_NULL,0,0,0,0,0,0,0,0,0,0,0);
+
+static const struct dinput_device *unix_devices[] =
+{
+    &joystick_linuxinput_device,
+    &joystick_linux_device,
+    &joystick_osx_device
+};
+
+static HRESULT CDECL unix_get_dinput_device(unsigned int index, const struct dinput_device **out)
+{
+    TRACE("index %d, out %p.\n", index, out);
+    if (index >= ARRAY_SIZE(unix_devices)) return E_FAIL;
+    *out = unix_devices[index];
+    return DI_OK;
+}
+
+const struct win32_funcs *win32_funcs;
+const struct unix_funcs unix_funcs =
+{
+    unix_get_dinput_device
+};
+
+NTSTATUS CDECL __wine_init_unix_lib( HMODULE module, DWORD reason, const void *ptr_in, void *ptr_out )
+{
+    TRACE("module %p, reason %d, ptr_in %p, ptr_out %p.\n", module, reason, ptr_in, ptr_out);
+    if (reason != DLL_PROCESS_ATTACH) return STATUS_SUCCESS;
+    win32_funcs = (const struct win32_funcs *)ptr_in;
+    *(const struct unix_funcs **)ptr_out = &unix_funcs;
+    return STATUS_SUCCESS;
+}
+
+const char *_dump_dinput_GUID(const GUID *guid) {
+    unsigned int i;
+    static const struct {
+	const GUID *guid;
+	const char *name;
+    } guids[] = {
+#define FE(x) { &x, #x}
+	FE(GUID_XAxis),
+	FE(GUID_YAxis),
+	FE(GUID_ZAxis),
+	FE(GUID_RxAxis),
+	FE(GUID_RyAxis),
+	FE(GUID_RzAxis),
+	FE(GUID_Slider),
+	FE(GUID_Button),
+	FE(GUID_Key),
+	FE(GUID_POV),
+	FE(GUID_Unknown),
+	FE(GUID_SysMouse),
+	FE(GUID_SysKeyboard),
+	FE(GUID_Joystick),
+	FE(GUID_ConstantForce),
+	FE(GUID_RampForce),
+	FE(GUID_Square),
+	FE(GUID_Sine),
+	FE(GUID_Triangle),
+	FE(GUID_SawtoothUp),
+	FE(GUID_SawtoothDown),
+	FE(GUID_Spring),
+	FE(GUID_Damper),
+	FE(GUID_Inertia),
+	FE(GUID_Friction),
+	FE(GUID_CustomForce)
+#undef FE
+    };
+    if (guid == NULL)
+	return "null GUID";
+    for (i = 0; i < ARRAY_SIZE(guids); i++) {
+	if (IsEqualGUID(guids[i].guid, guid)) {
+	    return guids[i].name;
+	}
+    }
+    return debugstr_guid(guid);
+}
+
+DWORD typeFromGUID(REFGUID guid)
+{
+    if (IsEqualGUID(guid, &GUID_ConstantForce)) {
+        return DIEFT_CONSTANTFORCE;
+    } else if (IsEqualGUID(guid, &GUID_Square)
+            || IsEqualGUID(guid, &GUID_Sine)
+            || IsEqualGUID(guid, &GUID_Triangle)
+            || IsEqualGUID(guid, &GUID_SawtoothUp)
+            || IsEqualGUID(guid, &GUID_SawtoothDown)) {
+        return DIEFT_PERIODIC;
+    } else if (IsEqualGUID(guid, &GUID_RampForce)) {
+        return DIEFT_RAMPFORCE;
+    } else if (IsEqualGUID(guid, &GUID_Spring)
+            || IsEqualGUID(guid, &GUID_Damper)
+            || IsEqualGUID(guid, &GUID_Inertia)
+            || IsEqualGUID(guid, &GUID_Friction)) {
+        return DIEFT_CONDITION;
+    } else if (IsEqualGUID(guid, &GUID_CustomForce)) {
+        return DIEFT_CUSTOMFORCE;
+    } else {
+        WARN("GUID (%s) is not a known force type\n", _dump_dinput_GUID(guid));
+        return 0;
+    }
+}
+
+INT WINAPI MulDiv( INT nMultiplicand, INT nMultiplier, INT nDivisor)
+{
+    LONGLONG ret;
+
+    if (!nDivisor) return -1;
+
+    /* We want to deal with a positive divisor to simplify the logic. */
+    if (nDivisor < 0)
+    {
+      nMultiplicand = - nMultiplicand;
+      nDivisor = -nDivisor;
+    }
+
+    /* If the result is positive, we "add" to round. else, we subtract to round. */
+    if ( ( (nMultiplicand <  0) && (nMultiplier <  0) ) ||
+         ( (nMultiplicand >= 0) && (nMultiplier >= 0) ) )
+      ret = (((LONGLONG)nMultiplicand * nMultiplier) + (nDivisor/2)) / nDivisor;
+    else
+      ret = (((LONGLONG)nMultiplicand * nMultiplier) - (nDivisor/2)) / nDivisor;
+
+    if ((ret > 2147483647) || (ret < -2147483647)) return -1;
+    return ret;
+}
+
+/*
+ * Maps POV x & y event values to a DX "clock" position:
+ *         0
+ *   31500    4500
+ * 27000  -1    9000
+ *   22500   13500
+ *       18000
+ */
+DWORD joystick_map_pov(const POINTL *p)
+{
+    if (p->x > 0)
+        return p->y < 0 ?  4500 : !p->y ?  9000 : 13500;
+    else if (p->x < 0)
+        return p->y < 0 ? 31500 : !p->y ? 27000 : 22500;
+    else
+        return p->y < 0 ?     0 : !p->y ?    -1 : 18000;
+}
+
+DWORD get_device_type(DWORD version, BOOL is_joystick)
+{
+    if (is_joystick)
+        return version >= 0x0800 ? DI8DEVTYPE_JOYSTICK | (DI8DEVTYPEJOYSTICK_STANDARD << 8) :
+                    DIDEVTYPE_JOYSTICK | (DIDEVTYPEJOYSTICK_TRADITIONAL << 8);
+
+    return version >= 0x0800 ? DI8DEVTYPE_GAMEPAD | (DI8DEVTYPEJOYSTICK_STANDARD << 8) :
+                DIDEVTYPE_JOYSTICK | (DIDEVTYPEJOYSTICK_GAMEPAD << 8);
+}
diff --git a/dlls/dinput/unixlib_private.h b/dlls/dinput/unixlib_private.h
new file mode 100644
index 00000000000..f330896d685
--- /dev/null
+++ b/dlls/dinput/unixlib_private.h
@@ -0,0 +1,38 @@
+/*
+ * Copyright 2020, Rémi Bernon for CodeWeavers
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#ifndef __WINE_DLLS_DINPUT_UNIXLIB_PRIVATE_H
+#define __WINE_DLLS_DINPUT_UNIXLIB_PRIVATE_H
+
+#include <stdarg.h>
+
+#include "windef.h"
+#include "winbase.h"
+#include "dinput.h"
+#include "wine/list.h"
+#include "wine/unicode.h"
+
+#include "dinput_private.h"
+#include "device_private.h"
+
+extern INT WINAPI MulDiv(INT nMultiplicand, INT nMultiplier, INT nDivisor) DECLSPEC_HIDDEN;
+extern DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
+extern DWORD typeFromGUID(REFGUID guid) DECLSPEC_HIDDEN;
+extern DWORD get_device_type(DWORD version, BOOL is_joystick) DECLSPEC_HIDDEN;
+
+#endif /* __WINE_DLLS_DINPUT_UNIXLIB_PRIVATE_H */
diff --git a/dlls/dinput/config.c b/dlls/dinput/config.c
index bf448985893..45cd0d63349 100644
--- a/dlls/dinput/config.c
+++ b/dlls/dinput/config.c
@@ -18,7 +18,6 @@
 
 #define NONAMELESSUNION
 
-#include "wine/unicode.h"
 #include "objbase.h"
 #include "dinput_private.h"
 #include "device_private.h"
diff --git a/dlls/dinput/device.c b/dlls/dinput/device.c
index 9f3e5af836e..5564de1ad5f 100644
--- a/dlls/dinput/device.c
+++ b/dlls/dinput/device.c
@@ -24,19 +24,21 @@
 
    It also contains all the helper functions.
 */
-#include "config.h"
 
 #include <stdarg.h>
 #include <string.h>
 #include <assert.h>
-#include "wine/debug.h"
-#include "wine/unicode.h"
+
 #include "windef.h"
 #include "winbase.h"
+#include "winnls.h"
 #include "winreg.h"
 #include "winuser.h"
 #include "winerror.h"
 #include "dinput.h"
+
+#include "wine/debug.h"
+
 #include "device_private.h"
 #include "dinput_private.h"
 #include "joystick_private.h"
@@ -660,10 +662,10 @@ static HKEY get_mapping_key(const WCHAR *device, const WCHAR *username, const WC
         'M','a','p','p','i','n','g','s','\\','%','s','\\','%','s','\\','%','s','\0'};
     HKEY hkey;
     WCHAR *keyname;
+    SIZE_T len = lstrlenW(subkey) + lstrlenW(username) + lstrlenW(device) + lstrlenW(guid);
 
-    keyname = HeapAlloc(GetProcessHeap(), 0,
-        sizeof(WCHAR) * (lstrlenW(subkey) + strlenW(username) + strlenW(device) + strlenW(guid)));
-    sprintfW(keyname, subkey, username, device, guid);
+    keyname = HeapAlloc(GetProcessHeap(), 0, sizeof(WCHAR) * len);
+    swprintf(keyname, len, subkey, username, device, guid);
 
     /* The key used is HKCU\Software\Wine\DirectInput\Mappings\[username]\[device]\[mapping_guid] */
     if (RegCreateKeyW(HKEY_CURRENT_USER, keyname, &hkey))
@@ -706,8 +708,8 @@ static HRESULT save_mapping_settings(IDirectInputDevice8W *iface, LPDIACTIONFORM
         if (IsEqualGUID(&didev.guidInstance, &lpdiaf->rgoAction[i].guidInstance) &&
             lpdiaf->rgoAction[i].dwHow != DIAH_UNMAPPED)
         {
-             sprintfW(label, format, lpdiaf->rgoAction[i].dwSemantic);
-             RegSetValueExW(hkey, label, 0, REG_DWORD, (const BYTE*) &lpdiaf->rgoAction[i].dwObjID, sizeof(DWORD));
+            swprintf(label, ARRAY_SIZE(label), format, lpdiaf->rgoAction[i].dwSemantic);
+            RegSetValueExW(hkey, label, 0, REG_DWORD, (const BYTE *)&lpdiaf->rgoAction[i].dwObjID, sizeof(DWORD));
         }
     }
 
@@ -745,7 +747,7 @@ static BOOL load_mapping_settings(IDirectInputDeviceImpl *This, LPDIACTIONFORMAT
         DWORD id, size = sizeof(DWORD);
         WCHAR label[9];
 
-        sprintfW(label, format, lpdiaf->rgoAction[i].dwSemantic);
+        swprintf(label, ARRAY_SIZE(label), format, lpdiaf->rgoAction[i].dwSemantic);
 
         if (!RegQueryValueExW(hkey, label, 0, NULL, (LPBYTE) &id, &size))
         {
diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 05763d0b3f4..498e60e55b2 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -30,7 +30,6 @@
  * - Fallout : works great in X and DGA mode
  */
 
-#include "config.h"
 #include <assert.h>
 #include <stdarg.h>
 #include <string.h>
@@ -52,7 +51,6 @@
 #include "dinputd.h"
 
 #include "wine/debug.h"
-#include "wine/unicode.h"
 #include "wine/asm.h"
 
 #include "dinput_private.h"
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 66ce63eb8e9..44732df0f2f 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -482,7 +482,7 @@ BOOL device_disabled_registry(const WCHAR* name)
 
     /* Look for the "controllername"="disabled" key */
     if (!get_config_key_w(hkey, appkey, name, buffer, sizeof(buffer)))
-        if (!strcmpW(disabled_str, buffer))
+        if (!lstrcmpW(disabled_str, buffer))
         {
             TRACE("Disabling joystick '%s' based on registry key.\n", debugstr_w(name));
             do_disable = TRUE;
@@ -790,12 +790,12 @@ static HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W i
     if (res != DI_OK) return res;
 
     if (pdidoi->dwType & DIDFT_AXIS) {
-        sprintfW(pdidoi->tszName, axisW, DIDFT_GETINSTANCE(pdidoi->dwType));
+        swprintf(pdidoi->tszName, MAX_PATH, axisW, DIDFT_GETINSTANCE(pdidoi->dwType));
         pdidoi->dwFlags |= DIDOI_ASPECTPOSITION;
-    } else if (pdidoi->dwType & DIDFT_POV)
-        sprintfW(pdidoi->tszName, povW, DIDFT_GETINSTANCE(pdidoi->dwType));
+    }
+    else if (pdidoi->dwType & DIDFT_POV) swprintf(pdidoi->tszName, MAX_PATH, povW, DIDFT_GETINSTANCE(pdidoi->dwType));
     else if (pdidoi->dwType & DIDFT_BUTTON)
-        sprintfW(pdidoi->tszName, buttonW, DIDFT_GETINSTANCE(pdidoi->dwType));
+        swprintf(pdidoi->tszName, MAX_PATH, buttonW, DIDFT_GETINSTANCE(pdidoi->dwType));
 
     _dump_OBJECTINSTANCEW(pdidoi);
     return res;
@@ -893,8 +893,8 @@ static HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W ifa
             if (!This->base.vendor_id || !This->base.product_id) return DIERR_UNSUPPORTED;
             is_gamepad = is_xinput_device(&This->devcaps, This->base.vendor_id, This->base.product_id);
             pd->guidClass = GUID_DEVCLASS_HIDCLASS;
-            sprintfW(pd->wszPath, formatW, This->base.vendor_id, This->base.product_id, is_gamepad ? igW : miW,
-                    This->base.instance_id);
+            swprintf(pd->wszPath, MAX_PATH, formatW, This->base.vendor_id, This->base.product_id,
+                    is_gamepad ? igW : miW, This->base.instance_id);
 
             TRACE("guidandpath(%s, %s): returning fake path\n", debugstr_guid(&pd->guidClass), debugstr_w(pd->wszPath));
             return DI_OK;
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 1d331d7fdef..92288224496 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -24,8 +24,9 @@
 #include "windef.h"
 #include "winbase.h"
 #include "dinput.h"
+
 #include "wine/list.h"
-#include "wine/unicode.h"
+
 #include "dinput_private.h"
 #include "device_private.h"
 
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index c3dc8b9319f..88ecb4a2c49 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -20,9 +20,6 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
-#include "config.h"
-#include "wine/port.h"
-
 #include <stdarg.h>
 #include <string.h>
 #include "windef.h"
@@ -31,10 +28,10 @@
 #include "winerror.h"
 #include "dinput.h"
 
+#include "wine/debug.h"
+
 #include "dinput_private.h"
 #include "device_private.h"
-#include "wine/debug.h"
-#include "wine/unicode.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index afaa7d14c8e..3d06d7fff56 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -19,9 +19,6 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
-#include "config.h"
-#include "wine/port.h"
-
 #include <stdarg.h>
 #include <string.h>
 
@@ -34,10 +31,10 @@
 #include "winreg.h"
 #include "dinput.h"
 
+#include "wine/debug.h"
+
 #include "dinput_private.h"
 #include "device_private.h"
-#include "wine/debug.h"
-#include "wine/unicode.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
@@ -683,9 +680,9 @@ static HRESULT WINAPI SysMouseWImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
     res = IDirectInputDevice2WImpl_GetObjectInfo(iface, pdidoi, dwObj, dwHow);
     if (res != DI_OK) return res;
 
-    if      (IsEqualGUID(&pdidoi->guidType, &GUID_XAxis)) strcpyW(pdidoi->tszName, x_axisW);
-    else if (IsEqualGUID(&pdidoi->guidType, &GUID_YAxis)) strcpyW(pdidoi->tszName, y_axisW);
-    else if (IsEqualGUID(&pdidoi->guidType, &GUID_ZAxis)) strcpyW(pdidoi->tszName, wheelW);
+    if (IsEqualGUID(&pdidoi->guidType, &GUID_XAxis)) lstrcpyW(pdidoi->tszName, x_axisW);
+    else if (IsEqualGUID(&pdidoi->guidType, &GUID_YAxis)) lstrcpyW(pdidoi->tszName, y_axisW);
+    else if (IsEqualGUID(&pdidoi->guidType, &GUID_ZAxis)) lstrcpyW(pdidoi->tszName, wheelW);
     else if (pdidoi->dwType & DIDFT_BUTTON)
         wsprintfW(pdidoi->tszName, buttonW, DIDFT_GETINSTANCE(pdidoi->dwType) - 3);
 
